<?php
class DistributorsController extends AppController
{


	var $helpers = array("Form");
	
	var $uses = array("Distributor");

	var $paginate = array(
        'limit' => 25,
        'order' => array(
            'Distributor.name' => 'asc'
        )
    );

	function add()
	{
	
   		if ($this->requireAccess(true, array("admin"))) {
			$controllerErrors=array();
			if (isset($_REQUEST['data'])) {
				// user hat daten eingegeben
				$user = $_REQUEST['data'];
				//print_r($user);
				
				if ( $this->Distributor->save($user) ) {
					$this->redirect("/distributors/show");
				}else {
					$this->set("errors", $this->Distributor->invalidFields());
				}
			} else {
				// user hat keine daten eingegeben
			}
			$this->set("controllerErrors", $controllerErrors);
		}
		
	}
	function deactivate($id)
	{
		if ($this->requireAccess(true, array("admin"))) {
		
			$distributor = $this->Distributor->read(null, $id);
			$distributor['Distributor']['isEnabled']="n";
			
			if ($this->Distributor->save($distributor))
			{
				$this->flash('Distributor (ID: '.$id.') wurde deaktiviert.', '/distributors/show');
			} else {
				$this->flash('Distributor (ID: '.$id.') konnte nicht deaktiviert werden.', '/distributors/show', 0);
			}
		}
	}
	function activate($id)
	{
		if ($this->requireAccess(true, array("admin"))) {
		
			$distributor = $this->Distributor->read(null, $id);
			$distributor['Distributor']['isEnabled']="y";
			
			if ($this->Distributor->save($distributor))
			{
				$this->flash('Distributor (ID: '.$id.') wurde aktiviert.', '/distributors/show');
			}
		}
	}
   function show()
   {
		if ($this->requireAccess(true, array("accountmanager", "admin"))) {

			$distributors = $this->paginate('Distributor');
			$this->set('distributors', $distributors);
			
			$this->set("loggedInRoleID", $this->getLoggedInRoleID());
			$this->set("adminRoleID", $this->getRoleIdByKey("admin"));

		}
    }
	function change($distributorID) 
	{
	
		if ($this->requireAccess(true, array("admin"))) {
			
			//print_r($this->params);
			if (isset($this->params["form"]["button"])) {
				$this->Distributor->save($this->params["data"]);
				$this->redirect("/distributors/show");
			}
		
			$distributor = $this->Distributor->find("Distributor.id=".$distributorID);
			$this->set(compact("distributor"));
		}
	}

}
?>
