<?php
class PaymentsController extends AppController
{


	var $helpers = array("Form");

	var $uses = array("Payment", "Config", "Manufacturer", "Csvstore", "Paymenttype", "Aclusersmanufacturer", "Acluserscsvstore", "Round", "Paymentcheck", "Closedround");

	var $paginate = array(
        'limit' => 100, // brauchma für /payments/check fürn rep
        'order' => array(
            'Payment.id' => 'asc' // bewusst nach Csvstore.uniqueExtID sortiert für /payments/show
        )
    );


	
	function deactivate($id)
	{
		if ($this->requireAccess(true, array("accountmanager"))) {
			$payment = $this->Payment->find("Payment.id=" . $id);
			
			$payment['Payment']['isEnabled']="n";
			
			if ($this->Payment->save($payment))
			{
				$this->flash('Payment (ID: '.$id.') wurde deaktiviert.', '/payments/show');
			} else {
				$this->flash('Payment (ID: '.$id.') konnte nicht deaktiviert werden.', '/payments/show', 0);
			}
		}
	}
	function activate($id)
	{
		if ($this->requireAccess(true, array("accountmanager"))) {
			$payment = $this->Payment->find("Payment.id=". $id);
			$payment['Payment']['isEnabled']="y";
	
			if ($this->Payment->save($payment))
			{
				$this->flash('Payment (ID: '.$id.') wurde aktiviert.', '/payments/show');
			}
		}
	}



	// "löscht"/deaktiviert eine zahlung
	// zusatzfunktion, nirgendwo im pflichtenheft spezifiziert
	function delete() {
		if ($this->requireAccess(true, array("accountmanager"))) {
			$payment['Payment']['id']=mysql_real_escape_string($_REQUEST['payment_id']);
			$payment['Payment']['isEnabled']='n';
			$this->Payment->save($payment);
			$this->redirect("/payments/show");
		}
	}

	function add() {
		if ($this->requireAccess(true, array("accountmanager"))) {

			$rounds = $this->Round->findAll("isEnabled='y' and uts_round_until > " . time() . " order by uts_round_until  asc "  );
			$this->set(compact('rounds'));
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			if ( isset($this->params['form']['button'])) {
				// user hat formular ausgefüllt und möchte daten speichern

				$payment = $this->params['data'];

				// an dieser stelle an die view übergeben, damit der user seine eingegeben daten und nichts abgeändertes sieht
				// bsp: user gibt ein: 1.2.2008, das wird 2 zeilen weiter unten auf uts konvertiert aber user soll im formular wieder 1.2.2008 und nicht den uts sehn
				$this->set("payment", $payment);

				// nachdem der user eingegen hat, werden manche formate noch konvertiert und daten hinzugefügt: zeit auf uts, userid und ip hinzugefügt
				$payment["Payment"]["payment_from_round_id"]=(int)($payment["Payment"]["payment_from_round_id"]);
				$payment["Payment"]["payment_until_round_id"]=(int)($payment["Payment"]["payment_until_round_id"]);
				$payment["Payment"]["uts_inserted"]=time();
				//$payment["Payment"]["uts_actiondate"]=strtotime($payment["Payment"]["uts_actiondate"]);
				$payment["Payment"]["user_id_inserted"]=$this->getLoggedInUserID();
				$payment["Payment"]["ip"]=$_SERVER['REMOTE_ADDR'];
				if (!isset($payment["Payment"]["hasToBeCheckedByRep"])) {
					$payment["Payment"]["hasToBeCheckedByRep"]= "n";
				}
	
	
	
				$fromRound = $this->Round->find("Round.id=" . $payment["Payment"]["payment_from_round_id"]);
				$untilRound = $this->Round->find("Round.id=" . $payment["Payment"]["payment_until_round_id"]);

				if  ($fromRound["Round"]["uts_round_until"] > $untilRound["Round"]["uts_round_until"]) {
					$this->flash("Eingabe konnte nicht gespeichert werden: KontrollZeitraumEnde  darf nicht zeitlich vor KontrollZeitraumStart  liegen", "/payments/add");
					return;
				}



				if ( $this->Payment->save($payment) ) {
					$this->flash("Zahlung erfoglreich eingetragen. Bitte beachten: Sollte sich der Zeitraum der Zahlung mit der aktuellen Runde überschneiden und der Rep die Zahlung überprüfen müssen kann es sein, dass die Zahlung erst zur nächsten Runde synchronisiert wird.", "/payments/show");
				} else {
					// save() hat nicht funktioniert, fehler in der eingabe
					$this->flash("Datenbankfehler. Leider konnte die Zahlung nicht gespeichert werden. Bitte versuchen Sie es zu einem späteren Zeitpunkt erneut.", "/payments/show");
					$this->set("errors", $this->Payment->invalidFields());
				}
			} else {
				// default werte für die view (bevor user seine eigenen daten eingegeben hat)
				$payment["Payment"]["payment_from_round_id"] = $currentroundid;
				$payment["Payment"]["payment_until_round_id"] = $currentroundid;
				$payment["Payment"]["amount"] = "0.0";
				$payment["Payment"]["rackwidth"] = 0;
				$payment["Payment"]["comment"] = "";
				$payment["Payment"]["paymenttype_id"] = 3;


				$this->set("payment", $payment);
			}


			
			
			// alle hersteller des users raussuchen
			$assignedManufacturers = $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID());
			$this->set(compact('assignedManufacturers'));
			//echo "assignedManufacturers: ";
			//print_r($assignedManufacturers);

			// für combobox
			//$manufacturers=$this->Manufacturer->findAll("isEnabled='y' order by name");
			//$this->set(compact('manufacturers'));

			// für combobox
			//$csvstores=$this->Csvstore->findAll("Csvstore.isEnabled='y' order by uniqueExtID");
			
			//$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() );
			//$this->set("csvstores", $assignedcsvstores);
			$csvstores = $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID()." AND Csvstore.isEnabled='y'",null,  "Csvstore.uniqueExtID asc");
			$this->set(compact('csvstores'));

			// für combobox
			$paymenttypes=$this->Paymenttype->findAll("isEnabled='y' ORDER BY sequence asc");
			$this->set(compact('paymenttypes'));
		}
	}


	// rep überprüft zahlungen
	function check() {
		if ($this->requireAccess(true, array("rep"))) {
			$rounds = $this->Round->findAll("isEnabled='y' and ( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().")"  );
			$this->set(compact('rounds'));
			$selectedroundid = $this->smartSession('Global.selectedroundid', @$_REQUEST['selectedroundid'], $rounds[0]['Round']['id']);
			$this->set(compact('selectedroundid'));
			
			$utsRoundUntil = $this->Round->getUtsRoundUntil($rounds, $selectedroundid);
			
			$aclusersmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID(). " order by name asc" );
			// In Array $assignedmanufacturers werden alle Hersteller gespeichert die, in der ausgewählten Runde, dem jeweiligen Rep zugeteilt waren.
			$assignedmanufacturers =  $this->getAssignedManufacturers($aclusersmanufacturers, $utsRoundUntil);
			$this->set("assignedManufacturers", $assignedmanufacturers);
			
			$selectedmanufacturerid = $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id'], 1, $this->extractIDs($assignedmanufacturers, "Manufacturer"));
			$this->set(compact('selectedmanufacturerid'));
			
			
			
			$acluserscsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID(). " order by uniqueExtID" );
			// In Array $assignedcsvstores werden alle Stores gespeichert die, in der ausgewählten Runde, dem jeweiligen Rep zugeteilt waren.
			$assignedcsvstores = $this->getAssignedCsvstores($acluserscsvstores, $utsRoundUntil);
			$this->set("csvstores", $assignedcsvstores);
			
			
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores[0]['Csvstore']['id'], 1, $this->extractIDs($assignedcsvstores, "Csvstore"));
			$this->set(compact('selectedcsvstoreid'));
			
			
			
			$currentroundid =$this->Round->getCurrentRoundID();
			$this->set(compact("currentroundid"));
			
			$selectedround =$this->Round->find("Round.id=" . $selectedroundid);
			
			
			if ($this->Closedround->isClosed($selectedroundid, $selectedmanufacturerid, $this->getLoggedInUserID())) {
				// runde bereits abgeschlossen, keine zahlungen mehr eingebbar
				$this->set("roundclosed", "Runde bereits abgeschlossen");
			} else {
			
				if (isset($this->params["form"]["button"]) && isset($this->params["data"]["Paymentchecks"])) {
					//print_r($this->data);
					foreach ($this->params["data"]["Paymentchecks"] as $paymentcheck_id => $value) {
						
						if ($value=="yes") {
							// aus db löschen, egal ob schon drin oder nicht
							$this->Paymentcheck->query("delete from paymentchecks where user_id=".$this->getLoggedInUserID(). " and payment_id=" . $paymentcheck_id);
							// in db eintragen
							$paymentcheck=array();
							unset($paymentcheck["Paymentcheck"]["id"]);
							$paymentcheck["Paymentcheck"]["id"]=0; // damit wird a insert statemen und ka update statement gebaut
							$paymentcheck["Paymentcheck"]["payment_id"]=$paymentcheck_id;
							$paymentcheck["Paymentcheck"]["round_id"]=$selectedroundid;
							$paymentcheck["Paymentcheck"]["uts_inserted"]=time();
							$paymentcheck["Paymentcheck"]["ip"]=$_SERVER['REMOTE_ADDR'];
							$paymentcheck["Paymentcheck"]["user_id"]=$this->getLoggedInUserID();
							
							if (!$this->Paymentcheck->save($paymentcheck)) {
								$this->flash('Datenbankfehler, Daten konnten nicht gespeichert werden.', '/payments/check', 0);
							}
							
			
			
						} elseif($value=="no") {
							// aus db löschen, egal ob schon drin oder nicht
							$this->Paymentcheck->query("delete from paymentchecks where user_id=".$this->getLoggedInUserID(). " and payment_id=" . $paymentcheck_id);
						}
						
					}
					// damit man nicht mit nem browser reload nochmal die datensätze einfügt sondern sauber zurückgeleitet wird
					
					// erfolgreich gespeichert, otherwise würde oben der datenbankerror ausgegeben werden
					// wäre nicht nötig aber reps wolln das so (bani 20090910)
					//$this->flash( "Daten erfolgreich gespeichert",  "/payments/check"); 
					$this->Session->setFlash('<div class="success-message"><img src="/img/hook_icon_small.png" alt="Hook Icon" /> Eingaben konnten erfolgreich gespeichert werden.</div>');
				}
			}	
			
			// eigentlich könnte man auch alle übergeben aber so machts weniger overhead
			$paymentchecks = $this->Paymentcheck->findAll("user_id=".$this->getLoggedInUserID() );
			$this->set(compact("paymentchecks")); 
			
			
			
			$payments = $this->paginate("Payment", array("Payment.isEnabled='y' and manufacturer_id= " .$selectedmanufacturerid . " and csvstore_id= " . $selectedcsvstoreid . 
			" and Roundfrom.uts_round_until <=" .$selectedround["Round"]["uts_round_from"] .
			" and Rounduntil.uts_round_until >=" .$selectedround["Round"]["uts_round_until"] 
			
			));
			
			//print_r($payments);
			//echo $payments[0]["Roundfrom"]["uts_round_until"];
			//echo "<font color=red>" . $payments[0]["Roundfrom"]["uts_round_from"] . "</font>";
			$this->set(compact("payments"));
		}
	}
	
	
	// In dieser Funktion werden alle dem User zugeteilten Märkte und Hersteller angezeigt, nicht nur jene die in diesem Jahr dem User zugeteilt waren.
	function show() {
		if ($this->requireAccess(true, array("accountmanager", "rep"))) {
		
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			$selectedyear = (int) $this->smartSession('Global.selectedyear', @$_REQUEST['selectedyear'], date("Y"));
			$this->set(compact('selectedyear'));
			
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() . " AND Csvstore.isEnabled='y'",null,  "Csvstore.uniqueExtID asc" );
			$this->set("assignedcsvstores", $assignedcsvstores);
			$selectedcsvstoreid = $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores [0]['Csvstore']['id']);
			$this->set(compact('selectedcsvstoreid'));
			
			$this->set("generalComboboxYearStart", $this->Config->getConfigValue("generalComboboxYearStart"));
			
			
			/*
			$assignedcsvstores =  $this->Acluserscsvstore->findAll("user_id=" . $this->getLoggedInUserID() ,null,  "Csvstore.uniqueExtID asc" );
			$this->set("assignedcsvstores", $assignedcsvstores);
			$selectedcsvstoreid = (int) $this->smartSession('Global.selectedcsvstoreid', @$_REQUEST['selectedcsvstoreid'], $assignedcsvstores[0]['Csvstore']['id']);
			$this->set(compact('selectedcsvstoreid'));
			*/
			
			$year = $selectedyear;
			$payments = $this->paginate('Payment', array("Payment.isEnabled='y' " .
				" and manufacturer_id='".$selectedmanufacturerid ."' " . 
				" and csvstore_id='".$selectedcsvstoreid . "' " . 
				" and Roundfrom.uts_round_until >=" . mktime(0,0,0,1,1,$year) .
				" and Rounduntil.uts_round_until <=" . mktime(0,0,-1,1,1,$year+1)   
			));
			
			
			
			
			
			
			
			$this->set(compact('payments'));
			
			$this->set("loggedInRoleID", $this->getLoggedInRoleID());
			$this->set("amRoleID", $this->getRoleIdByKey("accountmanager"));
			
			
			//exit(0);
		}
	}

	
}
?>
