<?php
class RoundsController extends AppController
{
	var $helpers = array("Form");

	var $uses = array("Round", "Aclusersmanufacturer", "Acluserscsvstore", "Deadline", "Task", "Taskcheck", "Payment", "Paymentcheck", "Closedround", "Report", "Order", "Nullorder", "Stockcheck", "Csvproduct", "Manufacturer", "Acltaskscsvstore");

	var $paginate = array(
        'limit' => 70,
        'order' => array(
            'Round.uts_round_until' => 'desc'
        )
    );

	// runde abschließen für den rep
	function close() {
		if ($this->requireAccess(true, array("rep"))) {
			//print_r($this->params);
			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			if (isset($this->params["data"]["Closedround"])) {
				$closeround = $this->params["data"];
				$closeround["Closedround"]["uts_closed"]=time();
				$closeround["Closedround"]["user_id"]=$this->getLoggedInUserID();
				$closeround["Closedround"]["ip"]=$_SERVER['REMOTE_ADDR'];
				$closeround["Closedround"]["manufacturer_id"]=$selectedmanufacturerid;
				
				  	
				//print_r($closeround);
				$this->Closedround->save($closeround);
			}
			
			
			
			$showdetails = (int) $this->smartSession('Global.showDetails', @$_REQUEST['showdetails'], "false");
			$this->set(compact('showdetails'));
			
			
			
			// diese hersteller betreut der rep
			$aclusersmanufacturers = $this->Aclusersmanufacturer->findAll("user_id=".$this->getLoggedInUserID());
			$this->set("aclusersmanufacturers", $aclusersmanufacturers);
			
			//Hier wird die uts zu der ein Rep einem Hersteller(in Combobox ausgewählter Herstellers) zugewiesen wurde rausgefiltert.(Achtung wir zählen exclusive)
			// Wird nur bei der SalesRep Ansicht benötigt
			foreach ($aclusersmanufacturers as $aclusersmanufacturer) {
				
				if ($aclusersmanufacturer["Aclusersmanufacturer"]["manufacturer_id"] == $selectedmanufacturerid) {
					$utsAssignedToManufacturer = $aclusersmanufacturer["Assignedroundfrom"]["uts_round_until"];
					break;
				}
			}
			

					
			$whereClause = ""; 
			// zeitlicher filter ********************
			// nicht alle runden zeigen sondern nur paar monate vor und paar monate nach aktuellem jahr
			// von okt letzten jahres
			$whereClause .= " and uts_round_until >" . mktime(0,0,0,date("m")-4,1,date("Y"));
			// bis märz nächsten jahres
			//$whereClause .= " and uts_round_until <" . mktime(0,0,0,3,1,date("Y")+1);
			// /zeitlicher filter ********************
			
			//Alte Version: Es werden nur noch nicht abgeschlossene Runden innerhalb eines Jahres angezeigt. (1.3.2011)
			/*$rounds = $this->paginate('Round', array( "Round.isEnabled='y' and  uts_round_until > $utsAssignedToManufacturer and( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().")" . $whereClause ) );
			$this->set('rounds', $rounds);*/
			
			$rounds = $this->paginate('Round', array( "Round.isEnabled='y' and  uts_round_until > $utsAssignedToManufacturer and( uts_round_until < ".time()." or Round.id=".$this->Round->getCurrentRoundID().")" ) );
			$this->set('rounds', $rounds);
			
			$this->set("closedrounds", $this->Closedround->findAll("user_id=".$this->getLoggedInUserID() . " and manufacturer_id=".$selectedmanufacturerid ));
			
			

			
			// diese stores betreut der rep
			$acluserscsvstores = $this->Acluserscsvstore->findAll("user_id=".$this->getLoggedInUserID());
			$this->set("acluserscsvstores", $acluserscsvstores);
			
		
			
			//brauchen wir das noch?????????????????????????????
			$usersstoreids=array();
			foreach ($acluserscsvstores as $acluserscsvstore) {
				array_push($usersstoreids, $acluserscsvstore["Csvstore"]["id"]) ;
			}
			$this->set("usersstoreids", $usersstoreids);
			
			
			
			// ******************** REPORTING *******************
			// diese reports hat der rep schon für den hersteller eingegeben
			$this->set("reports", $this->Report->findAll("Report.isEnabled='y' and manufacturer_id=" .$selectedmanufacturerid . " and user_id=".$this->getLoggedInUserID() ));
			// ******************** REPORTING *******************

			// ******************** AUFTRÄGE *******************
			
			//$this->set("tasks", $this->Task->findAll("Task.isEnabled='y' and manufacturer_id=".$selectedmanufacturerid . " and (1=0 or Csvstore.id =" . implode(" or Csvstore.id=", $usersstoreids) .")"));
			$this->set("tasks", $this->Acltaskscsvstore->findAll("Task.isEnabled='y' and manufacturer_id=".$selectedmanufacturerid . " and (1=0 or Csvstore.id =" . implode(" or Csvstore.id=", $usersstoreids) .")"));
			
			$this->set("taskchecks", $this->Taskcheck->findAll("Task.isEnabled='y' and manufacturer_id=" .$selectedmanufacturerid . " and user_id=".$this->getLoggedInUserID() ));
			
			//print_r($this->$tasks);
			// ******************** AUFTRÄGE *******************

			// ******************** BESTELLUNGEN *******************
			$this->set("orders", $this->Order->findAll("Order.isEnabled='y' and manufacturer_id=".$selectedmanufacturerid." and orderer_id=" .$this->getLoggedInUserID() ));
			
			$this->set("nullorders", $this->Nullorder->findAll("manufacturer_id =".$selectedmanufacturerid." and user_id=" .$this->getLoggedInUserID() ));
			// ******************** BESTELLUNGEN *******************


			// ******************** BESTANDSLISTE *******************
			$conditions = "Csvproduct.isEnabled='y' and shouldBeChecked='y' and manufacturer_id=" . $selectedmanufacturerid; 
			
			$this->set("csvproducts", $this->Csvproduct->findAll("Csvproduct.isEnabled='y' and shouldBeChecked='y' and manufacturer_id=" . $selectedmanufacturerid  ));
			
			$this->set("stockchecks", $this->Stockcheck->findAll("Csvproduct.manufacturer_id=".$selectedmanufacturerid. " and user_id=" .$this->getLoggedInUserID() ));
			// ******************** BESTANDSLISTE *******************
			
			
			// ******************** ZAHLUNGEN *******************
			$this->set("payments", $this->Payment->findAll("Payment.isEnabled='y' and hasToBeCheckedByRep='y' and manufacturer_id=".$selectedmanufacturerid));


			$this->set("paymentchecks", $this->Paymentcheck->findAll("	user_id=" .$this->getLoggedInUserID(). " AND Payment.manufacturer_id=". $selectedmanufacturerid ));
			// ******************** ZAHLUNGEN *******************
			
			$this->set("loggedInRoleID", $this->getLoggedInRoleID());
			
			$this->set('current_round_id', $this->Round->getCurrentRoundID() );
			
		}			
	}

	function administer() {
		if ($this->requireAccess(true, array("admin"))) {
			$rounds = $this->paginate('Round', array( ""  ) );
			$this->set('rounds', $rounds);
			
			$this->set('current_round_id', $this->Round->getCurrentRoundID() );
		}
	}

   function show()
   {
		if ($this->requireAccess(true, array("admin", "accountmanager"))) {
			// user ist als accountmanager eingelogged

			$assignedmanufacturers =  $this->Aclusersmanufacturer->findAll("user_id=" . $this->getLoggedInUserID() );
			$this->set("assignedmanufacturers", $assignedmanufacturers);
			$selectedmanufacturerid = (int) $this->smartSession('Global.selectedmanufacturerid', @$_REQUEST['selectedmanufacturerid'], $assignedmanufacturers[0]['Manufacturer']['id']);
			$this->set(compact('selectedmanufacturerid'));
			
			
			$selectedyear = (int) $this->smartSession('Global.selectedyear', @$_REQUEST['selectedyear'], date("Y"));
			$this->set(compact('selectedyear'));
			
			
			
			if ($selectedmanufacturerid > 0) {
				// user will nur einen hersteller sehn, daher filtern wir hier auf den einen hersteller
				// modell neu binden mit anderer bedingung
				//echo "modell vorher:";
				//print_r( $this->Round->hasMany);
				$currentHasMany = $this->Round->hasMany;
				$currentHasMany["Deadline"]["conditions"]=array('Deadline.manufacturer_id='.$selectedmanufacturerid);
				$this->Round->bindModel(
					array('hasMany' => $currentHasMany), false
				);
				//echo "Modell nachher: ";
				//print_r( $this->Round->hasMany);
			}
			
			$this->set('current_round_id', $this->Round->getCurrentRoundID() );
			
			$whereClause = "and uts_round_until>".mktime(0,0,0,1,1,$selectedyear) . " and uts_round_until<".mktime(0,0,-1,1,1,$selectedyear+1);
			
			//echo $whereClause;
			
			$rounds = $this->paginate('Round', array( "Round.isEnabled='y' " . $whereClause   ) );
			$this->set('rounds', $rounds);
			
			
			

			$this->set("tasks", $this->Task->findAll("Task.isEnabled='y'"));
			
			$this->set("loggedInRoleID", $this->getLoggedInRoleID());

			$this->set("productsInStockWithoutEOL", $this->Round->query("select count(*) as count from csvproducts where isEnabled='y' and manufacturer_id=".$selectedmanufacturerid." and eol_round_id=0"));
			$this->set("productsInStockWithEOL", $this->Round->query("select count(*) as count from csvproducts where isEnabled='y' and manufacturer_id=".$selectedmanufacturerid." and eol_round_id > 0" ));

		}
   }

	
	
	function setdeadline() {
		$data = $_REQUEST['data'];
		
		$round = $this->Round->find("Round.id = " . (int)$data['Deadline']['round_id'] );
		
		// default: deadline mit rundenende vorbelegen
		$data['Deadline']['uts_deadline'] = $round["Round"]["uts_round_until"];
		
		// deadline -> uts_deadline umwandeln
		if (isset($data['Deadline']['deadline'])) {
			// user will deadline speichern
			$data['Deadline']['uts_deadline']=strtotime($data['Deadline']['deadline']);
			unset($data['Deadline']['deadline']);
		}
		
		if ($this->Deadline->save($data)) {
			$this->flash("Daten konnten erfolgreich übernommen werden.");
		}else {
			$this->flash("Datenbankfeheler: Daten konnten NICHT übernommen werden.");
		}
		
	}
	
	
	
	function savedata() {
		$data = $_REQUEST['data'];
		
		$round = $this->Round->find("Round.id = " . (int)$data['Deadline']['round_id'] );
		$uts_round_until = $round["Round"]["uts_round_until"];
		$uts_round_from  = $this->Round->getUtsSingleRoundFrom((int)$data['Deadline']['round_id']);
		
		
		$deadline = $this->Deadline->find("manufacturer_id=" . (int) $data['Deadline']['manufacturer_id']. " and round_id= " . (int)$data['Deadline']['round_id'] );
		
		if (isset($deadline["Deadline"]["id"])) {
			// deadline war schon in der datenbank -> update statement
			$this->set(compact("deadline"));
		} else {
			// noch keine deadline in datenbank -> insert statement
			$deadline["Deadline"]["manufacturer_id"] = (int)$data['Deadline']['manufacturer_id'] ;
			$deadline["Deadline"]["round_id"] = (int)$data['Deadline']['round_id'] ;
		}
		
		
		
		if (trim($data['Deadline']['deadline']) != "") {
			// user hat deadline eingegeben
			$deadline['Deadline']['uts_deadline']=strtotime($data['Deadline']['deadline']);
		} else {
			// wenn user keine deadline eingegeben hat wird auf den letzten tag der runde defaultet
			$deadline['Deadline']['uts_deadline']=$uts_round_until-1; // 1 sekunde vor rundenschluss
		}
		
		if (isset($_REQUEST['btnSetDeadline'])) {
			// user will nur deadline setzen
			
		}
		
		$deadline['Deadline']['uts_committed'] = null; //"n";
		if (isset($_REQUEST['btnCloseRound'])) {
			// user will runde abschließen
			$deadline['Deadline']['uts_committed'] = time(); //"y"
		}
		
		
		if (	$deadline['Deadline']['uts_deadline'] >= $uts_round_from &&
					$deadline['Deadline']['uts_deadline'] <= $uts_round_until ) {
					
			// deadline liegt innerhalb der runde
		} else {
			// deadline liegt außerhalb der runde
			$this->flash("Daten können nicht gespeichert werden da die Deadline (".date("d.m.Y H:i", $deadline['Deadline']['uts_deadline']).") außerhalb der Runde ( ".date("d.m.Y H:i", $uts_round_from)." bis " .date("d.m.Y H:i", $uts_round_until). " ) liegt", "/rounds/show/");
			return;
		}
		
		
		
		//print_r($deadline);
		
		if ($this->Deadline->save($deadline)) {
			$repsInformed ="";
			if ($deadline['Deadline']['uts_committed'] > 0) { //"y"
				// user hat die runde abgeschlossen
				$this->informRepsAboutClosedRound($data['Deadline']["round_id"], $data['Deadline']["manufacturer_id"]);
				$repsInformed = "Die Reps wurden per Email informiert";
			}
			$this->flash("Daten konnten erfolgreich übernommen werden. $repsInformed", "/rounds/show/");
		} else {
			$this->flash("Datenbankfehler: Daten konnten NICHT gespeichert werden.", "/rounds/show/");
		}
	}
	
	function informRepsAboutClosedRound($round_id, $manufacturer_id) {
		$aclusersmanufacturers = $this->Aclusersmanufacturer->findAll("User.isEnabled='y' and manufacturer_id=".$manufacturer_id);
		
		$mailtemplate = $this->Config->getConfigValue("informRepsAboutClosedRound");
		$round = $this->Round->find("Round.id=".$round_id);
		$manufacturer = $this->Manufacturer->find("Manufacturer.id=" . $manufacturer_id);
		
		$rounddetails = $round["Round"]["description"] . " für " . $manufacturer["Manufacturer"]["name"];
		
		// schleife über alle emailempfänger (=reps)
		foreach ($aclusersmanufacturers as $aclusersmanufacturer) {
			$personalizedEmail = str_replace("###SALUTATION###",$aclusersmanufacturer["User"]["salutation"], $mailtemplate);
			$personalizedEmail = str_replace("###FIRSTNAME###",$aclusersmanufacturer["User"]["first_name"], $personalizedEmail);
			$personalizedEmail = str_replace("###LASTNAME###",$aclusersmanufacturer["User"]["last_name"], $personalizedEmail);
			$personalizedEmail = str_replace("###ROUNDDETAILS###",$rounddetails, $personalizedEmail);
			
			
			$this->sendMail($aclusersmanufacturer["User"]["email"], "Avalon: neue Runde freigegeben", $personalizedEmail);
		}
	}
	

	function deactivate($id)
		{
			$round = $this->Round->read(null, $id);
			$round['Round']['isEnabled']="n";

			if ($this->Round->save($round))
			{
				$this->flash('Round (ID: '.$id.') wurde deaktiviert.', '/rounds/administer');
			} else {
				$this->flash('Round (ID: '.$id.') konnte nicht deaktiviert werden.', '/rounds/administer', 0);
			}
	}

	function activate($id)
	{
		$round = $this->Round->read(null, $id);
		$round['Round']['isEnabled']="y";

		if ($this->Round->save($round))
		{
			$this->flash('Runde (ID: '.$id.') wurde aktiviert.', '/rounds/administer');
		}
	}
   function add()
   {
		if ($this->requireAccess(true, array("admin"))) {

			$rounds="";
			if (isset($this->params['form']['btnShow']) ||
				isset($this->params['form']['btnInsert'])
				) {
				$from = strtotime($this->params['form']['date_from']);
				$until = strtotime($this->params['form']['date_until']);



				$tmp = $from;
				$counter=0;
				while ($tmp < $until) {
					$counter++;

					// die anzeige Kalenderwoche (KW) soll immer den 1. tag des zeitraumes angeben
					$tmpCalendarWeek = mktime(date("H", $tmp), date("i", $tmp), date("s", $tmp), date("m", $tmp), date("d", $tmp), date("Y", $tmp));

					// hier berechnen wir die letzte sekunde des zeitraumes (eine sekunde wird später noch abgezogen)
					$tmp = mktime(date("H", $tmp), date("i", $tmp), date("s", $tmp), date("m", $tmp), date("d", $tmp) + $this->params['form']['interval_days'], date("Y", $tmp));
					
					//$uts_deadline = mktime(date("H", $tmp), date("i", $tmp), date("s", $tmp), date("m", $tmp), date("d", $tmp) - $this->params['form']['days_before_round_until'] , date("Y", $tmp));

					// -1: 1ne sekunde bevor 00:00h, damit 23:59 eingetragen wird: menschen rechnen immer inklusive einem tag, d.h. wenn man bis zum 4. zeit hat nimmt man an, dass man bis 4. 23:59 zeit hat und nicht bis 4. um 00:00
					$rounds .= "Besuchsrunde " . "(KW " . date("W", $tmpCalendarWeek) . " " . date("o", $tmpCalendarWeek) . ") " . date("d.m.Y H:i:s", $tmpCalendarWeek) . " bis " . date("d.m.Y H:i:s", $tmp-1) . "<br />";
					if (isset($this->params['form']['btnInsert'])) {
						$this->Round->query("insert into rounds set uts_round_inserted=".time().", uts_round_until = '".($tmp -1)."', description='Besuchsrunde (KW". date("W", $tmpCalendarWeek)  . " " . date("Y", $tmpCalendarWeek) .")'");
					}

				}



			}
			$this->set('rounds', $rounds);

			// ********** sticky form ******************

			// default values
			$formparams = $this->params['form'];
			if (!isset($formparams['date_from'])) {
				$formparams['date_from'] = "1.1." . date("Y");
			}
			if (!isset($formparams['date_until'])) {
				$formparams['date_until'] = "31.12." . date("Y");
			}
			if (!isset($formparams['interval_days'])) {
				$formparams['interval_days'] = "14";
			}
			
			if (!isset($formparams['days_before_round_until'])) {
				$formparams['days_before_round_until'] = "3";
			}

			// make form sticky
			$this->set('formparams', $formparams);
			// ********** sticky form ******************


			if (isset($this->params['form']['btnInsert'])) {
				// user hat neue runden eingefügt, nun zur rundenverwaltung umlenken
				$this->redirect('/rounds/administer');
			}

		}
   }
}
?>
