<?php
class Order extends AppModel
{
    var $name = 'Order';

	var $belongsTo= array('Distributor' =>
		array('className'    => 'Distributor',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'distributor_id'
		),

		'Round' =>
		array(
			  'className'    => 'Round',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'round_id'
		),
		'Manufacturer' =>
		array(
			  'className'    => 'Manufacturer',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'manufacturer_id'
		),
		'Csvstore' =>
		array(
			  'className'    => 'Csvstore',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'csvstore_id'
		),
		'User' =>
		array(
			  'className'    => 'User',
			  'conditions'   => '',
			  'order'        => '',
			  'foreignKey'   => 'orderer_id'
		),

	);

	function beforeSave() {




		// Nur wenn User Rep ist, die runde noch nciht abgeschlossen ist und die Bestellung von ihm eingeben wurde darf er diese auch deaktivieren
		//if (( !isset($roundclosed) && $getLoggedInRoleID == $repRoleID && $order['Order']['orderer_id'] == $userID) || $getLoggedInRoleID == $amRoleID) {

		//gehtnimma// if ($err=$this->isRoundClosed()) {
		//gehtnimma// 	$this->data['BeforeSave']['error'] = $err; return false;
		//gehtnimma// }
		if ($err=$this->isOrderFromLoggedInUserAndIsUserRep()) {
			$this->data['BeforeSave']['error'] = $err; return false;
		}
		return true; // keine regel oben angeschlagen
	}


	function isOrderFromLoggedInUserAndIsUserRep() {
		App::Import("AppController", "AppController");
		$appController = new AppController();
		$appController->constructClasses();

		// reps dürfen nur bestellungen speichern wenn die runde noch nicht abgeschlossen ist
		if ( $appController->getLoggedInRoleID() == $appController-> getRoleIdByKey("rep")) {
			// wurde diese bestellung vom eingeloggten user getätigt?
			if ($this->data["Order"]["orderer_id"] != $appController->getLoggedInUserID()) {
				return "Diese Bestellung gehört einem anderen Benutzer";
			}
		}
		return "";
	}

/*
	function isRoundClosed() {
		// nur wenn die runde noch nicht abgeschlossen ist
		App::Import("AppController", "AppController");
		$appController = new AppController();
		$appController->constructClasses();

		App::Import("Closedround", "Closedround");
		$closedround = new Closedround();

		// reps dürfen nur bestellungen speichern wenn die runde noch nicht abgeschlossen ist
		if ( $appController->getLoggedInRoleID() == $appController-> getRoleIdByKey("rep")) {
			if ($closedround->isClosed($this->data["Order"]["round_id"], $this->data["Order"]["manufacturer_id"], $appController->getLoggedInUserID() )) {
				// runde für den eingeloggten rep bereits abgeschlossen
				// -> rep darf bestellung nicht mehr ändern
				return "Runde bereits abgeschlossen";
			}
		}
		
		return ""; // is ok, runde noch nicht abgeschlossen
	}*/


	var $validate = array(
        'uts_orderdate' => array(
            'rule' => array('comparison', '>', 0),
			'message' => 'Bitte geben Sie ein Bestelldatum ein.'
		),
		// distributor ist kein pflichtfeld weil accounmanger auch bestellungen ohne disti aufnehmen kann
		'manufacturer_id' => array(
            'rule' => array('comparison', '>', 0),
			'message' => 'Bitte geben Sie einen Hersteller ein.'
		),
		'csvstore_id' => array(
            'rule' => array('comparison', '>', 0),
			'message' => 'Bitte geben Sie einen Markt ein.'
		),
		'totalsum' => array(
            'rule' => array('comparison', '>', 0),
			'message' => 'Bitte geben Sie einen Bestellsumme ein.'
		),
		'ordernumber' => array(
            'rule' => array('minLength', 0),
			'message' => 'Bitte geben Sie eine Bestellnummer ein.',
			'allowEmpty' => false,
		),

    );
}
?>